# AWS SDK for Node.js

## Developer Guide

The **AWS SDK for Node.js** allows JavaScript developers to build libraries or
applications that make use of AWS services using a simple and easy-to-use
API. The SDK is available as the [aws-sdk](http://npmjs.org/package/aws-sdk)
package for easy installation through [npm](http://npmjs.org).

## Overview

This guide will walk developers through many of the high level concepts
that the SDK provides, as well as provide example code to get started with
some services. For a more complete look at the classes and methods provided by
the library, it is recommended to look at the SDK's
[API reference documentation](http://docs.aws.amazon.com/AWSJavaScriptSDK/latest/frames.html).

## Sections

* {file:Installing.md Installing the SDK}
* {file:Configuring.md Configuring the SDK}
* {file:Services.md Working with Services}
* {file:MakingRequests.md Making Requests}
* {file:Examples.md Common Examples}
* {file:UPGRADING.md Upgrading Notes}

<div class="clear"></div>

## License

This SDK is distributed under the
[Apache License, Version 2.0](http://www.apache.org/licenses/LICENSE-2.0).
